<?php /* /momo/lib/lib_msg_public.php, (c) 2008, Andreas Forstinger, www.mobilemoodle.org */
/// this library is based on the sample msgserverinterface.php by Matthias Meisenberger, elibera.com

// msgInterfaceTest();

/**
 * tests the functions
 */
function msgInterfaceTest()
{
	$user="test"; // sample username
	$pass="1205760838793"; // sample encrypted password

	// print all online clients
	//print_r(msgInterfaceGetOnlineClients());

	// send a text message to the user, returns the new msg ID
	//echo msgInterfacesendtextmsg("titel1","mein text",$user,$pass);

	// update a msg with this ID, returns "ok" if successful
	//echo msgInterfaceupdatetextmsg("26","titel11","mein text 2",$user,$pass);

	// prints a list of all the messages of this user
	//print_r(msgInterfaceGetMsgsOfUser($user,$pass));

	// prints a full message with this ID
	//print_r(msgInterfaceGetMsg("26",$user,$pass));

	// attaches a binary to a message, and returns the ID of this new binary
	//echo msgInterfaceattachFileToMsg("210","/home/matthias/data/eclipse/mle/www/screenshots/menu.jpg","image/jpg",$user,$pass);

	// deletes a binary of a message, returns "ok" if successful
	//echo msgInterfacedeleteBinary("27",$user,$pass);

	// Prints out the binary data of a message:
	//header("Content-Type: image/jpg");
	//echo msgInterfacegetBinary("28",$user,$pass);

	//deletes a message, returns "ok" if successful
	//echo msgInterfacedeleteMsg("210",$user,$pass);

	// generates a ticket ID
	//echo generateMOMODownloadTicketID("http://www.mobileclassroom.at/moodle18/momo/index.php","myuser","mypass","123456");

	// generates the full download URL for the USER
	//echo generateMOMODownloadURL("http://www.mobileclassroom.at/moodle18/momo/index.php");

}
/**
 * returns the client info for this username
 * if this client is not online, null is returend
 */
function msgInterfaceGetClientIDForUsername($username)
{
    global $CFG;
	$res = msgInterfaceUtilSplitresult(msgInterfaceMsgServerInterfaceSend("onlineclientsoneuser","$username\n"));
	if(count($res)==1)
		return $res[0];
	$c=0;
	for($i=2;$i<count($res);$i=$i+$res[1])
	{
		if(($i+2)>=count($res))break;
		$client=array();
		$client["id"]=$res[$i];
		$client["username"]=urldecode($res[$i+1]);
		$client["password"]=urldecode($res[$i+2]);
		$client["servername"]=$CFG->momo_mle_msgserver_servername;
		$client["serverhost"]=$CFG->momo_msg_hostid;
		if(strcmp($client["username"],$username)==0)return $client;
	}
	return null;
    
}

/**
 * returns all online clients for this server
 */
function msgInterfaceGetOnlineClients()
{
	global $CFG;
	$res = msgInterfaceUtilSplitresult(msgInterfaceMsgServerInterfaceSend("onlineclients",""));
	if(count($res)==1)
		return $res[0];
	$clients = array();
	$c=0;
	for($i=2;$i<count($res);$i=$i+$res[1])
	{
		if(($i+2)>=count($res))break;
		$client=array();
		$client["id"]=$res[$i];
		$client["username"]=urldecode($res[$i+1]);
		$client["password"]=urldecode($res[$i+2]);
		$client["servername"]=$CFG->momo_mle_msgserver_servername;
		$client["serverhost"]=$CFG->momo_msg_hostid;
		//$clients[$c]=$client;
		$clients[$res[$i+1]]=$client;
		$c++;
	}
	return $clients;
}
/**
 * returns all the messages of the current user
 */
function msgInterfaceGetMsgsOfUser($username,$password)
{
	$res= msgInterfaceUtilSplitresult(msgInterfaceMsgServerInterfaceSend("msglist","",$username,$password));
	
	if(count($res)==1)
		return $res[0];
	$msgs = array();
	$c=0;
	for($i=2;$i<count($res);$i=$i+$res[1])
	{
		if(($i+2)>=count($res))break;
		$msg=array();
		$msg["id"]=$res[$i];
		$msg["createtime"]=urldecode($res[$i+1]);
		$msg["msgdelivered"]=urldecode($res[$i+2]);
		$msg["msgtaken"]=urldecode($res[$i+3]);
		$msg["isstringmsg"]=urldecode($res[$i+4]);
		$msg["title"]=urldecode($res[$i+5]);
		$msg["binaries"]=urldecode($res[$i+6]);
		$msgs[$c]=$msg;
		$c++;
	}
	return $msgs;
}
/**
 * returns a full message by it's id
 */
function msgInterfaceGetMsg($id,$username,$password)
{
	$res= msgInterfaceUtilSplitresult(msgInterfaceMsgServerInterfaceSend("getmsg",$id."\n",$username,$password));
	$msg=array();
	$i=1;
	$msg["id"]=$id;
	$msg["destination"]=urldecode($res[$i]);
	$msg["encoding"]=urldecode($res[$i+1]);
	$msg["title"]=base64_decode(urldecode($res[$i+2]));
	$msg["content"]=base64_decode(urldecode($res[$i+3]));
	$msg["binaries"]=urldecode($res[$i+4]);
	$msg["createtime"]=urldecode($res[$i+5]);
	$msg["touserid"]=urldecode($res[$i+6]);
	$msg["fromuserid"]=urldecode($res[$i+7]);
	$msg["msgdelivered"]=urldecode($res[$i+8]);
	$msg["msgtaken"]=urldecode($res[$i+9]);
	$msg["onlinemsg"]=urldecode($res[$i+10]);
	$msg["stringmsg"]=urldecode($res[$i+11]);
	if(strlen($msg["binaries"])>0)
	{
		$bins = split(";",$msg["binaries"]);
		$msg["binaries"]=array();
		for($i=0;$i<count($bins);$i++){
			$bin=array();
			$b=split(",",$bins[$i]);
			if(strlen($b[0])<=0)break;
			$bin["id"]=$b[0];
			$bin["contenttype"]=$b[1];
			$msg["binaries"][$i]=$bin;
		}
	}
	return $msg;
}
/**
 * returns the binary data
 */
function msgInterfaceGetBinary($binId,$username,$password)
{
	return msgInterfaceMsgServerInterfaceSend("getmsgbinary",$binId."\n",$username,$password);
}
/**
 * deletes a binary
 */
function msgInterfaceDeleteBinary($binId,$username,$password)
{
	return msgInterfaceMsgServerInterfaceSend("deletebinary",$binId."\n",$username,$password);
}
/**
 * deletes a full message an all of its binaries
 */
function msgInterfaceDeleteMsg($id,$username,$password)
{
	return msgInterfaceMsgServerInterfaceSend("deletemsg",$id."\n",$username,$password);
}
/**
 * attach the contents of a file to a message
 */
function msgInterfaceAttachFileToMsg($msgId,$filename,$contenttype,$username,$password)
{
	$handle = fopen($filename, "r");
	$contents = fread($handle, filesize($filename));
	fclose($handle);
	return msgInterfaceAttachBinaryToMsg($msgId,$filename,$contenttype,$contents,$username,$password);
}
/**
 * attach a binary to a message
 */
function msgInterfaceAttachBinaryToMsg($msgId,$binaryname,$contenttype,$binarydata,$username,$password)
{
	$data=$msgId."\n".$contenttype."\n".$binaryname."\n";
	return msgInterfaceMsgServerInterfaceSend("addbinary",$data,$username,$password,$binarydata);
}
/**
 * sends a text message to the given user
 * returns the new message id
 */
function msgInterfaceUpdateTextMsg($id,$titel,$content,$tousername,$topassword,$fromuserid="",$touserid="",$msgtaken="false",$msgdelivered="false")
{
	global $CFG;
	$destination=$CFG->momo_msg_destination;
	$msgtype=mb_convert_encoding($titel,"UTF-8",mb_detect_encoding($titel));
	$msgdata=mb_convert_encoding($content,"UTF-8",mb_detect_encoding($content));
	$encoding="UTF-8";
	return msgInterfaceUpdateMsg($id,$tousername,$topassword,$msgtype,$msgdata,$encoding,$destination,"true",$fromuserid,$touserid,$msgdelivered,$msgtaken);
}
function msgInterfaceUpdateMsg($id,$tousername,$topassword,$msgtype,$msgdata,$encoding,$msgdest,$isstringmsg="true",$fromuserid="",$touserid="",$ismsgdelivered="false",$ismsgtaken="false",$isonlinemsg="false")
{
	$data=$id."\n".time()."\n".$encoding."\n".$msgdest."\n".$fromuserid."\n".
	$touserid."\n".$isstringmsg."\n".$ismsgdelivered."\n".$ismsgtaken."\n".
	$isonlinemsg."\n";
	return msgInterfaceMsgServerInterfaceSend("updatemsg",$data,$tousername,$topassword,$msgtype,$msgdata);
}
/**
 * sends a text message to the given user
 * returns the new message id
 */
function msgInterfaceSendTextMsg($titel,$content,$tousername,$topassword,$destination=NULL,$fromuserid="",$touserid="")
{
	global $CFG;
	if(empty($destination))$destination=$CFG->momo_msg_destination;
	$msgtype=mb_convert_encoding($titel,"UTF-8",mb_detect_encoding($titel));
	$msgdata=mb_convert_encoding($content,"UTF-8",mb_detect_encoding($content));
	$encoding="UTF-8";
	return msgInterfaceSendMsg($tousername,$topassword,$msgtype,$msgdata,$encoding,$destination,"true",$fromuserid,$touserid);
}
function msgInterfaceSendMsg($tousername,$topassword,$msgtype,$msgdata,$encoding,$msgdest,$isstringmsg="true",$fromuserid="",$touserid="",$ismsgdelivered="false",$ismsgtaken="false",$isonlinemsg="false")
{
	$data=time()."\n".$encoding."\n".$msgdest."\n".$fromuserid."\n".
	$touserid."\n".$isstringmsg."\n".$ismsgdelivered."\n".$ismsgtaken."\n".
	$isonlinemsg."\n";
	return msgInterfaceMsgServerInterfaceSend("sendmsg",$data,$tousername,$topassword,$msgtype,$msgdata);
}
/**
 * sends the data to the msg-server over the web interface and returns the result
 */
function msgInterfaceMsgServerInterfaceSend($task,$data,$username="",$password="",$bindata=NULL,$bindata2=NULL)
{
	global $CFG;
	
	// check if we should connect to the public server
	if(!empty($CFG->momo_public_msg_enabled)){
		$host = $CFG->momo_public_msg_host;
		$port = $CFG->momo_public_msg_remote_port;		
	}
	else{
		$host = $CFG->momo_msg_host;
		$port = $CFG->momo_msg_remote_port;
	}
	
	$data=$task."\n".$CFG->momo_mle_msgserver_servername."\n".$CFG->momo_msg_hostid."\n".$username."\n".$password."\n".$data;
	//echo $data;
	return msgInterfaceMsgServerInterfaceFSockopen($host, $port, $data,$bindata,$bindata2);
}
/**
 * connection via fsockopen
 */
function msgInterfaceMsgServerInterfaceFSockopen($uri, $port, $data,$bindata=NULL,$bindata2=NULL)
{
	
	// bugfix: changed from is_int because we the config parameters are stored
	// as string values, so always port 80 was chosen
	if (!is_numeric($port)){
		$port = 80;
	}
		
	$uri = strtr(strval($uri), array (
		"http://" => "",
		"https://" => "ssl://",
		"ssl://" => "ssl://",
		"\\" => "/",
		"//" => "/"
	));

	if (($protocol = stripos($uri, "://")) !== FALSE)
	{
		if (($domain_pos = stripos($uri, "/", ($protocol +3))) !== FALSE)
		{
			$domain = substr($uri, 0, $domain_pos);
			$file = substr($uri, $domain_pos);
		} else {
			$domain = $uri;
			$file = "/";
		}
	} else
	{
		if (($domain_pos = stripos($uri, "/")) !== FALSE)
		{
			$domain = substr($uri, 0, $domain_pos);
			$file = substr($uri, $domain_pos);
		} else {
			$domain = $uri;
			$file = "/";
		}
	}

	$fp = fsockopen($domain, $port, $errno, $errstr, 30);
	// print($domain . $port);
	if (!$fp) {
		// print ($errno . $errstr);
		return "error:connect";
	} else
	{
		$response = "";
		//echo $data;
		fwrite($fp, $data);
		if($bindata!=NULL){
			fwrite($fp,strlen($bindata)."\n");
			fwrite($fp, $bindata);
		}
		if($bindata2!=NULL){
			fwrite($fp,strlen($bindata2)."\n");
			fwrite($fp, $bindata2);
		}
		while (!feof($fp)) {
			$c=fread($fp,1);
			if($c=="\n")break;
			$response .= $c;
		}
		$ret = '';
		  $read = 0;
		  while ($read < $response && ($buf = fread($fp, $response - $read))) {
		    $read += strlen($buf);
		    $content .= $buf;
		  }
		fwrite($fp, "ok");
		fclose($fp);
		//echo $content;
		return $content;
	}
}
function msgInterfaceUtilSplitresult($result)
{
	return split("\n",$result);
}
?>