<?php 
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/forum/lib.php'); // forum support

// get forum id
$id = optional_param('id',0,PARAM_INT);

// get forum
if(!$forum = get_record('forum', 'id', $id)){
    momo_print_error('error_parameter');
}

/// handle authentication
momo_login_to_course($forum->course);

// get course module
$cm = get_coursemodule_from_instance('forum', $forum->id, $forum->course);

// add log message, needed for reports and statistics
    if ($cm->id) {
        add_to_log($forum->course, 'forum', 'view forum', "view.php?id=$cm->id", "$forum->id", $cm->id);
    } else {
        add_to_log($forum->course, 'forum', 'view forum', "view.php?f=$forum->id", "$forum->id");
    }


$view_allowed = true;

$groups=array();
$groups=get_records_select('groups_members','userid='.$USER->id);
$groupList="";
if(!empty($groups))
{
    foreach($groups as $group)
    {
        $groupList.=",".$group->groupid;
    }
}
//momo_log($groupList,$action='forum debug',$url='');

/// now get the most recent discussions
$discussions = array();
$discussions = get_records_select('forum_discussions','forum='.$forum->id.' AND groupid in (-1,0'.$groupList.')','timemodified DESC','*','0','3');

$numDiscussions = 0;
if(!empty($discussions)){
    // get number of all discussions
    $numDiscussions = count_records_select('forum_discussions','forum='.$forum->id.' AND groupid in (-1,0'.$groupList.')');
}

?>
<ps t="<?php momo_print_string('hd_forum')?>" s="false" bo="true" back="<?php echo(momo_get_back_url($COURSE->id))?>">
<pa id="i">
<?php momo_print_header($forum->name, 'mod_forum') ?>
<?php if(!empty($message)){ // there is some message to display ?>
<br align="center"/><font class="h3" /><?php momo_print_string($message)?><font class="std"/><br align="left"/>
<?php } ?>
<?php
    if(empty($discussions)){ ?>
<?php momo_print_string('msg_forum_no_discussions')?><br/>
<?php
    } else{ ?>
<font class="h2" /><?php momo_print_string('lbl_forum_newest_discussions')?><font class="std"/><br/>
<?php
    // print latest discussions
    foreach($discussions as $discussion){ ?>
<menu t="<?php echo($CFG->momo_mle_server_link) ?>" url="forum/forum_discussion.php&amp;id=<?php echo($discussion->id) ?>" dt="l" di="<?php momo_print_icon_path('pst_discussion') ?>" w="<?php p(momo_truncate($discussion->name))?>" />
<?php }} ?>
<hr/>
<?php if($numDiscussions > 3){ ?>
<menu t="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_discussions.php&amp;id=<?php echo($forum->id)?>" dt="l" di="<?php momo_print_icon_path('pst_discussions') ?>" word="<?php momo_print_string('lbl_forum_discussions_all')?> (<?php echo($numDiscussions)?>)" />
<?php } ?>
<?php // check if user is allowed to start new discussions and if so, print link
if(forum_user_can_post_discussion($forum)){ ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_discussion_new.php&amp;forum=<?php echo($forum->id)?>" dt="l" di="<?php momo_print_icon_path('pst_discussion_new') ?>" word="<?php momo_print_string('lbl_forum_discussion_new')?>"/>
<?php } ?>
<menu type="i" url="d" dt="l" di="<?php momo_print_icon_path('info') ?>" word="<?php momo_print_string('lbl_general_details')?>"/>
</page>


<page id="d">
<font class="h1"/>
<image type="l" url="<?php momo_print_icon_path('info') ?>" /> <?php momo_print_string('hd_forum')?>
<font class="std"/><br/><hr/>
<font class="h2"/><?php momo_print_string('lbl_forum_name')?><br/>
<font class="std"/><?php p($forum->name)?><br/>
<font class="h2"/><?php momo_print_string('lbl_forum_intro')?><br/>
<font class="std"/><?php momo_print_converted_text($forum->intro)?><br/>
<back type="i" url="i"/>
</page>

</pagesuite>