<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/forum/lib.php'); // forum support

// get forum id from request
$forumid = optional_param('forum',null,PARAM_INTEGER);
if(empty($forumid)){
    momo_print_error('error_parameter');
}

// get forum object
if(!$forum = get_record('forum', 'id', $forumid)){
    momo_print_error('error_general');
}

/// handle authentication
momo_login_to_course($forum->course);

// check if data was submitted
$data = optional_param('data',null);

$showform = true;
$success = true;
if($data != null){ // form data has been submitted so process
    $showform = false;

    // get subject from post and clean (strip unwanted tags)
    $subject = clean_param(strip_tags(optional_param('subject','',PARAM_RAW), '<lang><span>'), PARAM_CLEAN);
    // get message from post (do NOT clean, it is cleaned on display)
    $message = optional_param('message','',PARAM_RAW);

    // create discussion object
    $discussion = new object;
    $discussion->forum = $forum->id;
    $discussion->course = $forum->course;
    $discussion->mailnow = optional_param('mailnow', 0, PARAM_BOOL);
    $discussion->name = $subject;
    $discussion->intro = $message;
    $discussion->format = FORMAT_PLAIN;
    $discussion->groupid = get_current_group($forum->course);
    if (isteacheredit($forum->course) and $discussion->groupid == 0) {
        $discussion->groupid = -1;
    }

    $discussion->course = $forum->course;
    $discussion->subscribe = optional_param('subscribe', 0, PARAM_BOOL);
    $discussion->unsubscribe = optional_param('unsubscribe', 0, PARAM_BOOL);

    // we do not care about timestart and timeend stuff at the moment
    $discussion->timestart = 0;
    $discussion->timeend = 0;

    // call function to add discussion
    $error = '';
    if ($discussion->id = forum_add_discussion($discussion,$message)) {
        add_to_log($forum->course, 'forum', 'add discussion',
                        "discuss.php?d=$discussion->id", "$discussion->id");

        $success = ($discussion->id > 0) ? true : false;
    }

    // print feedback
    if($success){
        momo_print_success(momo_get_string('msg_forum_discussion_added'),"forum/forum_discussion.php&amp;id=$discussion->id", $CFG->momo_mle_server_link);
    }
    else{
        momo_print_error(momo_get_string('msg_forum_discussion_failed'),"forum/forum.php&amp;id=$forum->id", $CFG->momo_mle_server_link);
    }

}

/// output
?>
<ps t="<?php momo_print_string('lbl_forum_discussion_new')?>" s="false" bo="false" back="<?php echo(momo_get_back_url($COURSE->id))?>">
<pa>
<?php momo_print_header(momo_get_string('lbl_forum_discussion_new'), 'pst_discussion_new') ?>
<?php if($showform){ // input form should be displayed ?>
<upload type="form"/>
<font class="h3"/><?php momo_print_string('lbl_forum_subject')?><font class="std"/><br/>
<textbox id="subject" value="new" size="20"><br/>
<font class="h3"/><?php momo_print_string('lbl_forum_message')?><font class="std"/><br/>
<textbox id="message" value="new" size="20"><br align="center"/>
<menu url="a" type="i" dt="mc" di="<?php momo_print_icon_path('add')?>" word="<?php momo_print_string('lbl_forum_attachement_add')?>" full="false"/><br/>
<upload type="hidden" name="forum" value="<?php echo($forum->id)?>" />
<upload type="hidden" name="data" value="true" />
<upload type="submit" url="forum/forum_discussion_new.php" location="<?php echo($CFG->momo_mle_server_link)?>" dt="l" display="<?php momo_print_icon_path('ok')?>" menuTag="<?php momo_print_string('nav_submit')?>" full="false"/><br/>
<menu url="forum/forum.php&amp;id=<?php echo($forum->id)?>" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('cancel')?>" word="<?php momo_print_string('nav_cancel')?>" full="false"/>
<?php }
    else{ ?>
<back type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum.php&amp;id=<?php echo($forum->id)?>"/>
<?php
    }
?>
</pa>

<?php if($showform){ // include page allowing an attachment (at the moment only an image)?>
<pa id="a">
<?php momo_print_header(momo_get_string('lbl_forum_attachement_add'), 'add') ?>
<?php momo_print_string('lbl_mm_snapshot')?><br/>
<recordimage id="attachment" /><br/>
<hr/><br align="center"/>
<upload type="submit" url="forum/forum_discussion_new.php" location="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('ok') ?>" menuTag="<?php momo_print_string('nav_submit')?>" full="false"/><br/>
<menu url="forum/forum.php&amp;id=<?php echo($forum->id)?>" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('cancel')?>" word="<?php momo_print_string('nav_cancel')?>" full="false"/>
</pa>
<?php } ?>

</ps>