<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/forum/lib.php'); // forum support

// get id of discussion
$discussionid = optional_param('discussion',null,PARAM_INTEGER);

// get id of post
$edit = optional_param('edit',null,PARAM_INTEGER);
if(!empty($edit)){
    $oldpost = get_record('forum_posts','id',$edit);
}

// get discussion
if(!empty($discussionid)){
    $discussion = get_record('forum_discussions','id',$discussionid);
}
// get parent posting
$parentid = optional_param('parent',0);
$parent = forum_get_post_full($parentid);

// check if data has already been submitted
$data = optional_param('data',null,PARAM_RAW);

// indicates whether the input form should be displayed
$showform = true;
$success = true;
if(!empty($data)){
    $showform = false;

    /// process form data
    // get subject from post and clean (strip unwanted tags)
    $subject = clean_param(strip_tags(optional_param('subject','',PARAM_RAW), '<lang><span>'), PARAM_CLEAN);
    // get message from post (do NOT clean, it is cleaned on display)
    $message = optional_param('message','',PARAM_RAW);

    if(!empty($edit)){
        $newpost = $oldpost;
    }
    else{
        // create post object
        $newpost = new object;
        $newpost->parent = $parentid;
        $newpost->forum = $discussion->forum;
        $newpost->discussion = $discussion->id;
    }

    $newpost->subject = $subject; //already cleaned
    $newpost->message = $message; //cleaning only before display
    $newpost->format = FORMAT_PLAIN;
    $newpost->mailnow = 0;
    $newpost->course = $discussion->course;
    $newpost->subscribe = optional_param('subscribe', 0, PARAM_BOOL);
    $newpost->unsubscribe = optional_param('unsubscribe', 0, PARAM_BOOL);

    $error = '';
    // check if new post is to be created or if we update an existing one
    if(!empty($edit)){ // we are in edit mode
        // update post
        forum_update_post($newpost,$error);
    }
    else{ // we create new one
        // add the new post to forum
        if ($newpost->id = forum_add_new_post($newpost,$error)) {
            add_to_log($discussion->course, 'forum', 'add post',
                              "discuss.php?d=$newpost->discussion&amp;parent=$newpost->id", "$newpost->id");
        }
        else{
            $success = false;
        }
    }

// we manually add attachement(s) (because our attachement parameters have different names)
    if ($newpost->attachment = forum_add_attachment($newpost, 'snapshot',$error)) {
        set_field('forum_posts', 'attachment', $newpost->attachment, 'id', $newpost->id);
    }
     if ($newpost->attachment = forum_add_attachment($newpost, 'comment',$error)) {
        set_field('forum_posts', 'attachment', $newpost->attachment, 'id', $newpost->id);
    }
    if ($newpost->attachment = forum_add_attachment($newpost, 'attfile',$error)) {
        set_field('forum_posts', 'attachment', $newpost->attachment, 'id', $newpost->id);
    }

    // print feedback
    if($success){
        momo_print_success(momo_get_string('msg_forum_post_added'),"forum/forum_discussion.php&amp;id=$discussion->id", $CFG->momo_mle_server_link);
    }
    else{
        momo_print_error(momo_get_string('msg_forum_post_failed'),"forum/forum_discussion.php&amp;id=$discussion->id", $CFG->momo_mle_server_link);
    }
}

// response
?>
<ps t="<?php momo_print_string('lbl_forum_post_new')?>" s="false" bo="false">
<pa id="i">
<?php
    // show header
    if(!empty($edit)){
        momo_print_header(momo_get_string('lbl_forum_edit'), 'pst_posting_new');
    }
    else{
        momo_print_header(momo_get_string('lbl_forum_post_new'), 'pst_posting_new');
    }
?>
<?php if($showform){ ?>
<upload type="form"/>
<font class="h3"/><?php momo_print_string('lbl_forum_subject') ?><font class="std"/><br/>
<textbox id="subject" value="Re: <?php if(!empty($edit)){p($oldpost->subject);}else{p($parent->subject);}?>" size="20"><br/>
<font class="h3"/><?php momo_print_string('lbl_forum_message') ?><font class="std"/><br/>
<textbox id="message" value="<?php if(!empty($edit)){p($oldpost->message);}else{echo('message');}?>" size="20">
<br align="center" />
<menu url="a" type="i" dt="mc" di="<?php momo_print_icon_path('add') ?>" word="<?php momo_print_string('lbl_forum_attachement_add')?>" full="false"/>
<upload type="hidden" name="discussion" value="<?php echo($discussion->id)?>" />
<upload type="hidden" name="parent" value="<?php echo($parentid)?>" />
<?php if(!empty($edit)){?>
<upload type="hidden" name="edit" value="<?php echo($oldpost->id)?>" />
<?php } ?>
<upload type="hidden" name="data" value="true" />
<br/><hr/>
<upload type="submit" url="forum/forum_post_new.php" location="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('ok') ?>" menuTag="<?php momo_print_string('nav_submit')?>" full="false"/><br/>
<menu url="forum/forum_discussion.php&amp;id=<?php echo($discussion->id)?>" type="<?php echo($CFG->momo_mle_server_link)?>" dt=l" di="<?php momo_print_icon_path('cancel')?>" word="<?php momo_print_string('nav_cancel')?>" full="false"/>
<?php     } ?>
</pa>

<?php if($showform){?>
<pa id="a">
<?php momo_print_header(momo_get_string('lbl_forum_attachement_add'), 'add') ?>
<?php momo_print_string('lbl_mm_snapshot')?><br/>
<recordimage id="snapshot" /><br/>
<?php momo_print_string('lbl_mm_comment')?><br/>
<recordaudio id="comment" /><br/>
<?php // if the device supports access to file system show file browser ?>
<eval type="sysprop" value="microedition.io.file.FileConnection.version">
<?php momo_print_string('lbl_forum_attachement_choose')?><br/>
<fileio id="attfile" /><br/>
</eval>
<hr/><br align="center"/>
<upload type="submit" url="forum/forum_post_new.php" location="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('ok') ?>" menuTag="<?php momo_print_string('nav_submit')?>" full="false"/><br/>
<menu url="forum/forum_discussion.php&amp;id=<?php echo($discussion->id)?>" type="<?php echo($CFG->momo_mle_server_link)?>" dt="l" di="<?php momo_print_icon_path('cancel')?>" word="<?php momo_print_string('nav_cancel')?>" full="false"/>
</pa>
<?php } ?>
</ps>